#!/bin/bash

########################################
#                                      #
#         ADRCI - HOUSEKEEPER          #
#           LEONARDO LOPES             #
#    www.leonardosantoslopes.com.br    #
#                                      #
########################################


ORACLE_BASE=$1
ORACLE_HOME=$2
TIME=$3
ORA_BASE_DIAG=${ORACLE_BASE}/diag/rdbms


if [ -z "${ORACLE_BASE}" ] || [ -z "${ORACLE_HOME}" ] || [ -z "${TIME}" ]; then

echo "Missing mandatory parameter(s): [ORACLE_BASE] or [ORACLE_HOME]."
echo "Please try again with the right values."

exit;

fi

DB_NR=`ls -ld ${ORA_BASE_DIAG}/* | wc -l`

x=1

while [ ${x} -lt ${DB_NR} ]; do

ORA_BASE_DIAG_DIR=`ls -ld $ORA_BASE_DIAG/* | awk 'ORS=";" {print $9}' | cut -d ';' -f${x} | sed "s|${ORACLE_BASE}/||g"`

echo -e "set homepath ${ORA_BASE_DIAG_DIR}; purge -age ${TIME} -type ALERT" | $ORACLE_HOME/bin/adrci
echo -e "set homepath ${ORA_BASE_DIAG_DIR}; purge -age ${TIME} -type CDUMP" | $ORACLE_HOME/bin/adrci
echo -e "set homepath ${ORA_BASE_DIAG_DIR}; purge -age ${TIME} -type TRACE" | $ORACLE_HOME/bin/adrci
echo -e "set homepath ${ORA_BASE_DIAG_DIR}; purge -age ${TIME} -type INCIDENT" | $ORACLE_HOME/bin/adrci

x=$((x+1))

done