#! /bin/bash

cd ~/scripts/bin/

GREEN="\033[1;32;40m"
ORANGE="\033[33;44m"
RED="\033[1;37;41m"
BLUE="\033[1;30;46m"
CYAN="\033[1;36;40m"
NORM="\033[0m"
BOLD="\033[1m"
GREEN="\033[1;32;40m"
ORANGE="\033[33;40m"
RED="\033[1;31;40m"
BLUE="\033[1;34;40m"


CURL_CMD=$(which curl 2>/dev/null)
WGET_CMD=$(which wget 2>/dev/null)

check_CURL ()
{
  is_curl_available=1
  if [[ -z $RAT_CURL_CMD ]]; then
    CURL_CMD=$(which curl 2>/dev/null)
    if [[ -z "$CURL_CMD" || `echo $?` -ne 0 || `echo "$CURL_CMD" | grep -ic "no curl"` -gt "0" ]]; then
      unset CURL_CMD
      is_curl_available=0
    fi 
  else
    CURL_CMD=$RAT_CURL_CMD
  fi
}

check_WGET ()
{
  is_wget_available=1
  if [[ -z $RAT_WGET_CMD ]]; then
    WGET_CMD=$(which wget 2>/dev/null)
    if [[ -z "$WGET_CMD" || `echo $?` -ne 0 || `echo "$WGET_CMD" | grep -ic "no wget"` -gt "0" ]]; then
      unset WGET_CMD
      is_wget_available=0 
    fi
  else
    WGET_CMD=$RAT_WGET_CMD
  fi  
}

download_using_CURL ()
{
  echo ""
  echo -e "Entering curl..."
  $CURL_CMD --user $2:$3 --cookie-jar $4 --location-trusted "$1" -o $6 --verbose 2>>$5
  if [[ `grep -ic 'HTTP/1.1 401 Unauthorized' $LOGFIL` -gt 0 ]]; then
    curl_return_code=0 
  elif [[ `grep -ic 'SSL certificate problem' $LOGFIL` -gt 0 ]]; then
    curl_return_code=2 
  else 
    curl_return_code=1
  fi
  echo -e "Exiting curl with code $curl_return_code."
}

download_using_WGET ()
{
  echo -e "Entering wget..."
  SSO_RESPONSE=`$WGET_CMD --user-agent="Mozilla/5.0" https://$8/Orion/Services/download 2>&1|grep Location`
  # Extract request parameters for SSO
  if [[ `echo "$SSO_RESPONSE"|grep -ic "Location"` -gt "0" ]]; then
    SSO_TOKEN=`echo "$SSO_RESPONSE"| cut -d '=' -f 2|cut -d ' ' -f 1`
    SSO_SERVER=`echo "$SSO_RESPONSE"| cut -d ' ' -f 2|cut -d 'p' -f 1,2`
    SSO_AUTH_URL=sso/auth
    AUTH_DATA="ssousername=$2&password=$3&site2pstoretoken=${SSO_TOKEN}"
    
    # The following command to authenticate uses HTTPS. This will work only if the wget in the environment
    # where this script will be executed was compiled with OpenSSL. Remove the --secure-protocol option
    # if wget was not compiled with OpenSSL
    # Depending on the preference, the other options are --secure-protocol= auto|SSLv2|SSLv3|TLSv1

    # Contact updates site so that we can get SSO Params for logging in
    $WGET_CMD --user-agent="Mozilla/5.0" --secure-protocol=auto --post-data $AUTH_DATA --save-cookies=$4 --keep-session-cookies ${SSO_SERVER}${SSO_AUTH_URL} -O $5 >> $6 2>&1

    if [[ -e $4 ]]; then
      if [[ `grep -ic "$8" "$4"` -gt 0 ]]; then
        echo ""
        $WGET_CMD --user-agent="Mozilla/5.0" --load-cookies=$4 --save-cookies=$4 --keep-session-cookies "$1" -O $7 >>$6 2>&1
        wget_return_code=1
      else
        wget_return_code=0 
      fi
    else
      wget_return_code=2
    fi
  else
    wget_return_code=2
    $WGET_CMD --user-agent="Mozilla/5.0" https://$8/Orion/Services/download 2>>$6
  fi
  echo -e "Exiting wget with code $wget_return_code."
}

URL_HOST="updates.oracle.com"
#RAT_DOWNLOAD_BUGNO="18622611" (ora) | RAT_DOWNLOAD_BUGNO="17302090" ( exa)
#DOWNLOAD_LINK="https://$URL_HOST/Orion/Services/search?bug=$RAT_DOWNLOAD_BUGNO"
#https://updates.oracle.com/Orion/Services/search?bug=18622611"
DOWNLOAD_LINK="https://$URL_HOST/Orion/Services/search?bug=18622611"

program_name=exachk
LOGFIL=${program_name}_download.log
SSO_USERNAME="first.namr@corp.com"
SSO_PASSWORD="xxxxxxx"
RTEMPDIR=/tmp
OUTPUTDIR="."
COOKIE_FILE=$RTEMPDIR/$$.cookies
SSOFIL=$RTEMPDIR/sso.out
DOWNLOADED_ZIP=${program_name}.zip
DOWNLOADED_XML=download.xml

if [[ -n $CURL_CMD ]]; then
  download_using_CURL "$DOWNLOAD_LINK" "$SSO_USERNAME" "$SSO_PASSWORD" "$COOKIE_FILE" "$LOGFIL" "$DOWNLOADED_XML"
  if [[ -n $curl_return_code && $curl_return_code -eq "2" ]]; then
    check_WGET
    if [[ -n $is_wget_available && $is_wget_available -eq "1" ]]; then
      download_using_WGET "$DOWNLOAD_LINK" "$SSO_USERNAME" "$SSO_PASSWORD" "$COOKIE_FILE" "$SSOFIL" "$LOGFIL" "$DOWNLOADED_XML" "$URL_HOST"
    fi
  fi
else
  download_using_WGET "$DOWNLOAD_LINK" "$SSO_USERNAME" "$SSO_PASSWORD" "$COOKIE_FILE" "$SSOFIL" "$LOGFIL" "$DOWNLOADED_XML" "$URL_HOST"
  if [[ -n $wget_return_code && $wget_return_code -eq "2" ]]; then
    check_CURL
    if [[ -n $is_curl_available && $is_curl_available -eq "1" ]]; then
      download_using_CURL "$DOWNLOAD_LINK" "$SSO_USERNAME" "$SSO_PASSWORD" "$COOKIE_FILE" "$LOGFIL" "$DOWNLOADED_XML"
    fi
  fi
fi

if [[ -f "$DOWNLOADED_XML" ]]
then
   DOWNLOAD_URL=`grep -w download_url $DOWNLOADED_XML|sed 's/.*https/https/'|sed 's/\.zip\]\].*/\.zip/'|sed 's/"><!\[CDATA\[//'|grep ${program_name}`;
   zipname=`echo $DOWNLOAD_URL|sed 's/.*=//'`
   DOWNLOADED_ZIP=$zipname
fi

echo -e ""
echo -e "Started downloading.... $zipname from $DOWNLOAD_URL"
if [[ -n $CURL_CMD ]]; then
  download_using_CURL "$DOWNLOAD_URL" "$SSO_USERNAME" "$SSO_PASSWORD" "$COOKIE_FILE" "$LOGFIL" "$DOWNLOADED_ZIP" 
  if [[ -n $curl_return_code && $curl_return_code -eq "2" ]]; then
    check_WGET
    if [[ -n $is_wget_available && $is_wget_available -eq "1" ]]; then
      download_using_WGET "$DOWNLOAD_URL" "$SSO_USERNAME" "$SSO_PASSWORD" "$COOKIE_FILE" "$SSOFIL" "$LOGFIL" "$DOWNLOADED_ZIP" "$URL_HOST"
    fi
  fi
else
  download_using_WGET "$DOWNLOAD_URL" "$SSO_USERNAME" "$SSO_PASSWORD" "$COOKIE_FILE" "$SSOFIL" "$LOGFIL" "$DOWNLOADED_ZIP" "$URL_HOST"
  if [[ -n $wget_return_code && $wget_return_code -eq "2" ]]; then
    check_CURL
    if [[ -n $is_curl_available && $is_curl_available -eq "1" ]]; then
      download_using_CURL "$DOWNLOAD_URL" "$SSO_USERNAME" "$SSO_PASSWORD" "$COOKIE_FILE" "$LOGFIL" "$DOWNLOADED_ZIP" 
    fi
  fi
fi

#Display/return messages....
if [[ -n $curl_return_code && $curl_return_code -eq "1" ]] || [[ -n $wget_return_code && $wget_return_code -eq "1" ]]; then  
  DOWNLOAD_STATUS=1
  
  echo ""
  echo -e "${GREEN}${program_name}.zip successfully downloaded.${NORM}"
  echo ""
elif [[ -n $curl_return_code && $curl_return_code -eq "0" ]] || [[ -n $wget_return_code && $wget_return_code -eq "0" ]]; then 
  DOWNLOAD_STATUS=0
  #rm -f $DOWNLOADED_ZIP >/dev/null 2>&1

  echo ""
  echo -e "${RED}Incorrect username or password.${NORM}"
  echo -e "${RED}Please run ${program_name} -download.${NORM}"
  echo ""

  echo "Incorrect username or password." >>$LOGFIL
elif [[ -n $curl_return_code && $curl_return_code -eq "2" ]] && [[ -n $wget_return_code && $wget_return_code -eq "2" ]]; then
  DOWNLOAD_STATUS=0
  #rm -f $DOWNLOADED_ZIP >/dev/null 2>&1

  echo ""
  echo  -e "${RED}curl: SSL certificate problem and wget: Unexpected problem. Please review $LOGFIL for more detail${NORM}"    
  echo ""
elif [[ -n $curl_return_code && $curl_return_code -eq "2" ]]; then
  DOWNLOAD_STATUS=0
  #rm -f $DOWNLOADED_ZIP >/dev/null 2>&1

  echo ""
  echo  -e "${RED}curl: SSL certificate problem. Please review $LOGFIL for more detail${NORM}"
  echo ""
elif [[ -n $wget_return_code && $wget_return_code -eq "2" ]]; then
  DOWNLOAD_STATUS=0
  #rm -f $DOWNLOADED_ZIP >/dev/null 2>&1

  echo ""
  echo  -e "${RED}wget: Unexpected problem. Please review $LOGFIL for more detail${NORM}"
  echo ""
fi
