-- -----------------------------------------------------------------------------------
-- File Name    : https://oracle-base.com/dba/monitoring/longops.sql
-- Author       : Tim Hall
-- Description  : Displays information on all long operations.
-- Requirements : Access to the V$ views.
-- Call Syntax  : @longops
-- Last Modified: 03/07/2003
-- -----------------------------------------------------------------------------------
SET LINES 200 PAGES 2000
COLUMN SID FORMAT 99999
COLUMN SERIAL# FORMAT 9999999
COLUMN MACHINE FORMAT A30
COLUMN USERNAME FORMAT A20
COLUMN PROGRESS_PCT FORMAT 99999999.00
COLUMN ELAPSED FORMAT A10
COLUMN REMAINING FORMAT A10
COLUMN PROGRAM FORMAT A30
COLUMN MODULE FORMAT A30

SELECT S.SID,
       S.SERIAL#,
       S.USERNAME,	
       S.MACHINE,
       S.MODULE,
--       S.PROGRAM,
       ROUND(SL.ELAPSED_SECONDS/60) || ':' || MOD(SL.ELAPSED_SECONDS,60) ELAPSED,
       ROUND(SL.TIME_REMAINING/60) || ':' || MOD(SL.TIME_REMAINING,60) REMAINING,
       TO_CHAR(ROUND(SL.SOFAR/DECODE(SL.TOTALWORK, 0, 1,SL.TOTALWORK)*100, 2)) PROGRESS_PCT
FROM   V$SESSION S,
       V$SESSION_LONGOPS SL
WHERE  S.SID     = SL.SID
AND    S.SERIAL# = SL.SERIAL#
ORDER BY PROGRESS_PCT
/

