--- PROVIDE SQL_ID

DECLARE
MY_TASK_NAME VARCHAR2(30);
BEGIN
MY_TASK_NAME := DBMS_SQLTUNE.CREATE_TUNING_TASK(
SQL_ID => '&sql_id',
SCOPE => 'COMPREHENSIVE',
TIME_LIMIT => 500,
TASK_NAME => 'SQL_TUNE_&SQLID_AD',
DESCRIPTION => 'TUNE SQL QUERY');
END;
/

--- EXEC TASK

EXECUTE DBMS_SQLTUNE.EXECUTE_TUNING_TASK (TASK_NAME => 'SQL_TUNE_&SQLID_AD');

--- CHECK EXEC STATUS

SELECT STATUS FROM DBA_ADVISOR_LOG WHERE TASK_NAME='SQL_TUNE_&SQLID_AD';

--- GENERATE REPORT ==> HERE YOU WILL FIND THE RECOMMENDATION IF ANY

SELECT DBMS_SQLTUNE.REPORT_TUNING_TASK('SQL_TUNE_&SQLID_AD') FROM DUAL;

--- DROP THE SQLTUNE TASK

EXECUTE DBMS_SQLTUNE.DROP_TUNING_TASK('SQL_TUNE_&SQLID_AD');
