exec dbms_stats.FLUSH_DATABASE_MONITORING_INFO(); 

REM To list the objects having stale statistics (excluding SYS, SYSTEM, SYSMAN, DBSNMP objects)
REM Run the following from SYS or SYSTEM
set lines 120
column owner format a20
column table_name format a30
SELECT DT.OWNER,
       DT.TABLE_NAME, DT.LAST_ANALYZED,
       ROUND ( (DELETES + UPDATES + INSERTS) / NUM_ROWS * 100) STALE_PERCENT, NUM_ROWS
FROM   DBA_TABLES DT, DBA_TAB_MODIFICATIONS DTM
WHERE      DT.OWNER = DTM.TABLE_OWNER
       AND DT.TABLE_NAME = DTM.TABLE_NAME
       AND NUM_ROWS > 0 
       AND ROUND ( (DELETES + UPDATES + INSERTS) / NUM_ROWS * 100) >= 10 AND OWNER NOT IN ('SYS','SYSTEM','SYSMAN','DBSNMP')
ORDER BY 4 ,5 ;
