---### EXECUTAR ADVISOR FRAGMENTED TABLE
VARIABLE ID NUMBER;
BEGIN
  DECLARE
  NAME VARCHAR2(100);
  DESCR VARCHAR2(500);
  OBJ_ID NUMBER;
  BEGIN
  NAME:='Fragmented Table';
  DESCR:='Segment Advisor Fragmented Table';

  DBMS_ADVISOR.CREATE_TASK (
    ADVISOR_NAME     => 'Segment Advisor',
    TASK_ID          => :ID,
    TASK_NAME        => NAME,
    TASK_DESC        => DESCR);

  DBMS_ADVISOR.CREATE_OBJECT (
    TASK_NAME        => NAME,
    OBJECT_TYPE      => 'TABLE',
    ATTR1            => '&OWNER',
    ATTR2            => '&TABLE_NAME',
    ATTR3            => NULL,
    ATTR4            => NULL,
    ATTR5            => NULL,
    OBJECT_ID        => OBJ_ID);

  DBMS_ADVISOR.SET_TASK_PARAMETER(
    TASK_NAME        => NAME,
    PARAMETER        => 'RECOMMEND_ALL',
    VALUE            => 'TRUE');

  DBMS_ADVISOR.EXECUTE_TASK(NAME);
  END;
END;
/

---### VERIFICAR STATUS DA TASK FRAGMENTED TABLE
SELECT OWNER, TASK_NAME, STATUS FROM DBA_ADVISOR_TASKS
WHERE TASK_NAME = 'Fragmented Table';

---###VERIFICAR O ADVISOR PARA A TABELA SOBRE A TASK FRAGMENTED TABLE
COL MESSAGE FOR A80
COL SEGNAME FOR A20
COL PARTITION FOR A20
COL TYPE FOR A20
SELECT AF.TASK_NAME, AO.ATTR2 SEGNAME, /*AO.ATTR3 PARTITION, AO.TYPE,*/ AF.MESSAGE
FROM DBA_ADVISOR_FINDINGS AF, DBA_ADVISOR_OBJECTS AO
WHERE AO.TASK_ID = AF.TASK_ID
AND AO.OBJECT_ID = AF.OBJECT_ID
AND AF.TASK_NAME = 'Fragmented Table'
/

---### DROPAR ADVISOR FRAGMENTED TABLE
EXEC DBMS_ADVISOR.DELETE_TASK('Fragmented Table');
