column TABLESPACE format a30
column total_mb format 999,999,999,999.99
column used_mb format 999,999,999,999.99
column free_mb format 999,999,999.99
column pct_used format 999.99
column graph format a25 heading "GRAPH (X=5%)"
column status format a10
compute SUM OF total_mb ON report
compute SUM OF used_mb ON report
compute SUM OF free_mb ON report
BREAK ON report
SET lines 200 pages 300
SELECT total.ts TABLESPACE,
  DECODE(total.mb,NULL,'OFFLINE',dbat.status) status,
  total.mb total_mb,
  NVL(total.mb - free.mb,total.mb) used_mb,
  NVL(free.mb,0) free_mb,
  DECODE(total.mb,NULL,0,NVL(ROUND((total.mb - free.mb)/(total.mb)*100,2),100)) pct_used,
  CASE
    WHEN (total.mb IS NULL)
    THEN '['
      ||RPAD(LPAD('OFFLINE',13,'-'),20,'-')
      ||']'
    ELSE '['
      || DECODE(free.mb,NULL,'XXXXXXXXXXXXXXXXXXXX',NVL(RPAD(LPAD('X',TRUNC((100-ROUND( (free.mb)/(total.mb) * 100, 2))/5),'X'),20,'-'),'--------------------'))
      ||']'
  END AS GRAPH
FROM
  (SELECT tablespace_name ts,
    SUM(bytes)/1024/1024 mb
  FROM dba_data_files
  GROUP BY tablespace_name
  ) total,
  (SELECT tablespace_name ts,
    SUM(bytes)/1024/1024 mb
  FROM dba_free_space
  GROUP BY tablespace_name
  ) free,
  dba_tablespaces dbat
WHERE total.ts=free.ts(+)
AND total.ts  =dbat.tablespace_name
UNION ALL
SELECT sh.tablespace_name,
  'TEMP',
  SUM(sh.bytes_used       +sh.bytes_free)/1024/1024 total_mb,
  SUM(sh.bytes_used)      /1024/1024 used_mb,
  SUM(sh.bytes_free)      /1024/1024 free_mb,
  ROUND(SUM(sh.bytes_used)/SUM(sh.bytes_used+sh.bytes_free)*100,2) pct_used,
  '['
  ||DECODE(SUM(sh.bytes_free),0,'XXXXXXXXXXXXXXXXXXXX', NVL(RPAD(LPAD('X',(TRUNC(ROUND((SUM(sh.bytes_used)/SUM(sh.bytes_used+sh.bytes_free))*100,2)/5)),'X'),20,'-'),'--------------------'))
  ||']'
FROM v$temp_space_header sh
GROUP BY tablespace_name
ORDER BY GRAPH;